% definizione della matrice
A = [2 -1 0 3; 1 1 0 -2; 3 0 1 1; -2 -2 4 1];

% calcolo degli autovettori
autov = eig(A);

% traccia = somma autovalori
At1 = trace(A);
At2 = sum(autov);

disp(' ')
disp('traccia della matrice')
disp(num2str(At1))

disp(' ')
disp('somma degli autovalori')
disp(num2str(At2))

% determinante = prodotto autovalori
Ad1 = det(A);
Ad2 = prod(autov);

disp(' ')
disp('determinante della matrice')
disp(num2str(Ad1))

disp(' ')
disp('prodotto degli autovalori')
disp(num2str(Ad2))

%  diagonalizzazione della matrice
disp('diagonalizzazione')
[M,V] = eig(A);
D = inv(M)*A*M